# WP Data Access

* Contributors: [PeterSchulzNL](https://wpdataaccess.com/)
* Donate link: https://www.paypal.me/kpsch
* Requires at least: WordPress 4.8.3
* Tested up to: WordPress 5.9
* Stable tag: 5.1.1
* License: GPLv2 or later
* License URI: http://www.gnu.org/licenses/gpl-2.0.html

Local and remote data administration, publication and app development tool available directly from the WordPress dashboard.

## Description

WP Data Access is a powerful data administration, publication and development tool that allows you to perform database related tasks from your WordPress dashboard. An intuitive user interface helps to create fully responsive publications and data administration pages. No programming skills required!

For advanced users, the plugin support more complex features like remote database access, master-detail pages, lookups, WordPress role integration, WordPress user integration and a layer around your WordPress database which allows you to add database table and view specific functionality like dynamic hyperlinks and WordPress media library integration.

### Dashboards and data widgets
> Design your own dashboards using custom data widget

* Manage all your data on one location
* Share data widgets on back-end, public and external pages (PREMIUM)

### Data Publisher
> Publish responsive tables

* Easy level: no coding skills required
* Advanced level: JSON configuration
* Expert level: add custom JavaScript functions
* Export to CSV, Excel, PDF and SQL (PREMIUM)
* Print publication (PREMIUM)
* Copy publication to clipboard (PREMIUM)
* Full-text search (PREMIUM)
* Multiple advanced search options (PREMIUM)

### Charts
> Create charts from SQL queries (Query Builder integration)

* Bar, column, line and pie charts, histograms, gauges and data tables

### Data Explorer
> Data and database administration

* Manage local and remote databases
* Import and exports multiple formats
* WordPress Media Library integration
* Inline editing (PREMIUM)
* Full-text search (PREMIUM)
* Multiple advanced search options (PREMIUM)

### Query Builder
> Execute SQL directly from your WordPress dashboard

* Work on multiple SQL queries simultaneously (using tabs)
* Save and reuse queries
* Protects WordPress table structures and data

### Data Projects
> Write your own WordPress apps

* Auto generated CRUD pages (including parent-child relationships and lookups)
* WordPress role integration
* WordPress media library integration
* Accessible from the WordPress dashboard and public pages
* Inline editing (PREMIUM)
* Full-text search (PREMIUM)
* Multiple advanced search options (PREMIUM)

### Data Forms (PREMIUM)
> State of the art responsive data apps

* Turn your Data Project into a responsive data app (no additional configuration needed)

### Geolocation (PREMIUM)
> Turn your database table into searchable map

* Google Maps integration
* Define map settings per table
* Dynamic marker layout configuration
* Use static or user location
* Search map within adjustable radius

### Data Designer
> Create tables and indexes

* Create and alter tables and indexes
* Supports reverse engineering and reconciliation

### Plugin Settings
> Manage plugin behaviour, style and security

* Many detailed plugin settings
* User access and permission
* Integrated WordPress role management

### Sources

[» Plugin Website](https://wpdataaccess.com/)
[» Download plugin](https://wordpress.org/plugins/wp-data-access/) 
[» What's New](https://wpdataaccess.com/docs/documentation/updates/whats-new/)
[» Documentation](https://wpdataaccess.com/docs/documentation/)

## License

WP Data Access is licensed under the [GPL v2](http://www.gnu.org/licenses/gpl-2.0.html) or later.

> This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License, version 2, as
published by the Free Software Foundation.

> This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

> You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
